// ComExec.cpp - aplication to run something in silent mode
#include <windows.h>
#include <string.h>
#include "Define.h"
#include "MyFunc.h"
#include <stdio.h>
#include <stdlib.h>

char* create_string_param(const char* _string,const char* _delim)
{
	int i,j;
	char* _p=strstr(_string,_delim);
	if(_p==NULL)
		return NULL;
	
	for(i=0;_p[i]==_delim[i];i++);
	i+=1;
	_p+=i;
	i=0;

	for(j=0;_p[j]!=' ';j++);
	char* _encode=new char[j-i+2];
	
	if(j==i)
		return NULL;

	for(;i!=j;i++)
		_encode[i]=_p[i];
	_encode[i]='\0';
	
	char* _str=new char[strlen(_encode)+1];
	int _len=base64_decode_binary((unsigned char*)_str,_encode);
	_str[_len]='\0';
	
	delete[] _encode;
	return _str;
};

unsigned long create_number_param(const char* _string,const char* _delim)
{
	char* _str=create_string_param(_string,_delim);
	if(_str==0)
		return 0;
	unsigned long _res=atol(_str);
	delete[] _str;
	return _res;
}

int WINAPI WinMain(HINSTANCE,HINSTANCE,LPSTR lpCmdLine,int)
{
	int _res=AER_NO_ERROR;
	char* _file=create_string_param((char*)lpCmdLine,EXC_FILE);
	if(_file==NULL)
	{
		_file=new char[1];
		_file[0]='\0';
	};
	char* _cmdline=create_string_param((char*)lpCmdLine,EXC_CMDLINE);
	if(_cmdline==NULL)
	{
		_cmdline=new char[1];
		_cmdline[0]='\0';
	};
	char* _work_folder=create_string_param((char*)lpCmdLine,EXC_WORKFOLDER);
	unsigned long _time=create_number_param((char*)lpCmdLine,EXC_TIMEOUT);
	unsigned long _memory=create_number_param((char*)lpCmdLine,EXC_SPACELIM);

	char* _cmd_line=NULL;

	unsigned long _type;
	STARTUPINFO _si;
	PROCESS_INFORMATION _pi;
	ZeroMemory(&_si,sizeof(_si));
	_si.cb=sizeof(_si);
	ZeroMemory(&_pi,sizeof(_pi));
	try
	{
		BOOL _err=GetBinaryType(_file,&_type);
		
		if(_err==FALSE)
			throw RER_NOT_EXECUTABLE;

		_cmd_line=new char[strlen(_cmdline)+strlen(_file)+10];
		sprintf(_cmd_line,"\"%s\" %s",_file,_cmdline);

		if(CreateProcess(NULL,_cmd_line,NULL,NULL,FALSE,CREATE_NO_WINDOW,NULL,_work_folder,&_si,&_pi)==0)
			throw RER_CREATE_PROCESS;
		
		unsigned long _result=WaitForSingleObject(_pi.hProcess,_time);
		if(_result==WAIT_TIMEOUT)
		{
			TerminateProcess(_pi.hProcess,0);
			throw ERR_TIME_OUT;
		};
		GetExitCodeProcess(_pi.hProcess,&_result);
		if(_result!=0)
			throw ERR_RUNTIME;
	}
	catch(int _error)
	{
		_res=_error;
	}

	CloseHandle(_pi.hProcess);
	CloseHandle(_pi.hThread);
	delete[] _cmd_line;
	delete[] _work_folder;
	delete[] _file;
	delete[] _cmdline;
	return _res;
}