// Console.h - header file for CConsole class
#pragma once

#include <windows.h>
#include "Interface.h"

class CConsole : public CInterface
{
public:
	CConsole();
	virtual void print(const char* _text);
	virtual void update_tasks(void);
	void tick(void);
	~CConsole();

protected:
	HANDLE std_out;
	HANDLE std_in;
	unsigned int tasks_number;
	unsigned int x_size;		// window size
	unsigned int y_size;
	
	SMALL_RECT scroll_rect;
	SMALL_RECT tasks_rect;
	COORD new_scroll_pos,new_line,cursor_pos;
	CHAR_INFO char_fill;

	virtual int init(char* _buff);
	int apply(void);

private:
	unsigned long printed;
	void redraw_border(unsigned int _task_number);
	void update_border(void);
	void hide_border(void);
	void show_border(void);
	void printxy(unsigned int _x,unsigned int _y,const char* _text,unsigned int _n);
	void table_hline(char* _buff,char _symb,char _first,char _last,char _delim);
};