// Define.h - file for definitions and others macros
#pragma once

//all errors
#define AER_NO_ERROR 0
#define AER_WRONG_TASK 1
#define AER_WRONG_COMPILER 2

//initialization errors
#define IER_CANT_OPEN_FILE 101
#define IER_CANT_READ_FILE 102
#define IER_CANT_CLOSE_FILE 103
#define IER_NO_INFORMATION 104
#define IER_WRONG_INI_FILE 105
#define IER_CANT_APPLY 106
#define IER_NO_COMPILERS 107
#define IER_CANT_REMOVE_DIR 108
#define IER_CANT_REMOVE_FILE 109
#define IER_CANT_CREATE_DIR 110
#define IER_SOCKET_NOT_CREATED 111
#define IER_UNKNOWN_ERROR 10000

//runtime errors
#define RER_CREATE_FILE 200
#define RER_WRITE_FILE 201
#define RER_COPY_FILE 202
#define RER_DELETE_FILE 203
#define RER_MOVE_FILE 203
#define RER_CREATE_PROCESS 204
#define RER_COMEXEC_TIMEOUT 205
#define RER_NOT_EXECUTABLE 206
#define RER_CONNETION_FAILED 207
#define RER_READ_FILE 208
#define RER_CLOSE_FILE 209

//received errors
#define RCR_NO_ERROR 0
#define RCR_WRONG_ANSWER 301

//DONE codes
#define DONE_TESTER_ERROR -2
#define DONE_SERVER_ERROR -1
#define DONE_NO_ERROR 0
#define DONE_COMPILE_ERROR 1
#define DONE_TIME_OUT_ERROR 2
#define DONE_SECURITY_ERROR 3
#define DONE_RUN_TIME_ERROR 4
#define DONE_FORMAT_ERROR 5
#define DONE_WRONG_ANSWER_ERROR 6

//base
#define INI_FILE_NAME "ConTester.ini"

// socket initialization
#define SOCKET_CHAPTER "[SOCKET]"
#define SCK_HOST "hostname"
#define SCK_PORT "port"
#define MAX_HOST_LENGTH 20

//compiler options
#define COMPILER_CHAPTER "[COMPILER]"
#define CMP_NAME "name"
#define CMP_FILE "file"
#define CMP_OPTIONS "options"
#define CMP_WORKFOLDER "dir"
#define CMP_TIMEOUT "timeout"
#define CMP_EXTENSION "ext"
#define CMP_MAX_LENGTH 1000

//compiler
#define SOURCE_PLACE "?s"
#define FOLDER_PLACE "?f"

//interface
#define INTERFACE_CHAPTER "[INTERFACE]"

//console interface
#define MAX_TASK_NUMBER 10
#define HPOS_TASK 50
#define HPOS_RECV 60
#define HPOS_ACTD 70

//something
#define NEW_LINE "\x0d\x0a"
#define DOUBLE_NEW_LINE "\x0d\x0a\x0d\x0a"
#define MAX_CMDLINE_LENGTH 1000

//comexec param
#define EXC_FILE "-?src"
#define EXC_CMDLINE "-?cmd"
#define EXC_TIMEOUT "-?tmr"
#define EXC_SPACELIM "-?spc"
#define EXC_WORKFOLDER "-?wkf"
#define EXC_TIME_LIMIT 1000

//folders
#define FOLDER_CHAPTER "[FOLDERS]"
#define FLD_SOURCE "source"
#define FLD_WORK "work"
#define FLD_TEST "test"
#define FLD_MAX_LENGTH 1000

//errors
#define ERR_VALUE 1000
#define ERR_NO_ERROR 0
#define ERR_COMPILER ERR_VALUE
#define ERR_COMPILER_NO 1
#define ERR_WRONG_ANSWER 2*ERR_VALUE
#define ERR_WRONG_ANSWER_NO 2
#define ERR_TIME_OUT 3*ERR_VALUE
#define ERR_TIME_OUT_NO 3
#define ERR_RUNTIME 4*ERR_VALUE
#define ERR_RUNTIME_NO 4
#define ERR_WRONG_OUTPUT 5*ERR_VALUE
#define ERR_WRONG_OUTPUT_NO 5
#define ERR_SECURITY 6*ERR_VALUE
#define ERR_SECURITY_NO 6

//headers
#define HDR_TEST_ID "__TEST__"
#define HDR_OUTPUT_ID "__OUTPUT__"
#define HDR_FILTER_ID "__FILTER__"
#define HDR_GRAMMAR_ID "__GRAMMAR__"
#define HDR_SOLUTION_ID "__SOLUTION__"
#define HDR_CRLF "\n"
#define HDR_SPACE "\n"

// test
#define TST_INPUT_FILE "input.txt"
#define TST_OUTPUT_FILE "output.txt"
#define TST_TOUTPUT_FILE "toutput.txt"
#define TST_FILTER_FILE "check"
#define TST_SOLUTION_FILE "solution"
#define TST_TSOLUTION_FILE "tsol"
#define TST_GRAMMAR_FILE "grammar"
#define TST_TEST_FILE "test"
#define TST_NO_TEST -1
#define TST_NO_TASK -1
#define TST_NO_TIME_LIMIT -1
#define TST_DEFAULT_COMPILER "bc31"

//execute
#define EXC_DONE 0
