// Folder.h - header file for folder storage class CFolder
#pragma once

#include "Init.h"
#include "Interface.h"

class CFolder : public CInit
{
public:
	CFolder(CInterface* _screen);
	const char* get_wf(void);
	const char* get_sf(void);
	const char* get_tf(void);
	int store_file(const char* _filename,const char* _buff,unsigned long _size);
	int make_folder(const char* _path);
	int copy_file(const char* _to,const char* _from);
	int delete_file(const char* _file);
	int delete_dir(const char* _path);
	bool file_exists(const char* _file);
	int rename_file(const char* _to,const char* _from);
	char* create_path(const char* _folder,const char* _file,const char* _ext);
	void delete_path(char* _path);
	~CFolder();
protected:
	char* work_folder;
	char* source_folder;
	char* test_folder;
	CInterface* screen;
	virtual int init(char* _buff);
	int check_folders(void);
	int clear_wf(void);
private:
	int setup_folder(const char* _path,bool _msg);
	int create_dir(const char* _path);
};