// Problem.h - header file for CProblem class
#pragma once
#include "Test.h"
#include "TestInfo.h"
#include "TaskInfo.h"
#include "FViser.h"
#include "CompilerService.h"
#include "FilterService.h"

class CProblem : public CFViser
{
public:
	CProblem(const char* _folder,CFolder* _cfolder,CInterface* _screen,CCompilerService* _compiler);
	const char* get_folder(void);
	int update_test(STestInfo& _test_info);
	int update_task(STaskInfo& _task_info);
	int test(const char* _solution,CFilterService* _filter);
	unsigned long get_time(void);
	unsigned long get_space(void);
	bool filter_exist(void);
	const char* get_filter_file(void);
	bool solution_exist(void);
	const char* get_solution_file(void);
	bool grammar_exist(void);
	const char* get_grammar_file(void);
	~CProblem();
protected:
	struct STestNode
	{
		CTest* test;
		int number;
		STestNode* next;

		STestNode(CTest* _test,int _number);
		STestNode* find_number(int _number);
		void add_next(STestNode* _next);
		~STestNode();
	};
	STestNode* tests;
	CCompilerService* compiler;
	unsigned long time_limit;
	unsigned long space_limit;
private:
	char* problem_folder;
	char* filter_file;
	char* solution_file;
	char* grammar_file;
	int store_data(STestInfo::SBody& _body,const char* _file);
	int update_file(STestInfo::SBody& _body,char*& _file_var,const char* _file);
};