#ifndef _RRDATA_H
#define _RRDATA_H
	
#include <string>
#include <map>
#include <iostream>
	
using std::string;
using std::map;
using std::ostream;
using std::endl;

struct RRData
{
	struct t_protocol
	{
		string name;
		struct t_version
		{
			unsigned int minor;
			unsigned int major;
			friend ostream & operator << (ostream &, const t_version &);
		} version;
		friend ostream & operator << (ostream &, const t_protocol &);
	} protocol;
	
	struct t_command
	{
		string name;
		string parameter;
		friend ostream & operator << (ostream &, const t_command &);
	} command;
	
	class t_headers : public map< string, string >
	{
		
	} headers;

	typedef std::pair< string, string > t_header;
	
	string body;

	struct t_params{
		t_params(): param1(0), param2(0) {}
		t_params(long int param1_, long int param2_): param1(param1_), param2(param2_) {}
		long int param1;
		long int param2;
	} params;
	
	friend ostream & operator << (ostream &, const RRData &);
};
	
#endif
