// Tasks.h - header file for CTasks class
#pragma once
#include "Task.h"
#include "Counter.h"
#include "Interface.h"

class CTasks : public CCounter
{
public:
	CTasks();
	void clear(void);
	void inc_total(void);
	void inc_accept(void);
	void inc_refuse(void);
	void update(void);
	void update_task(unsigned int _number,const char* _name);
	CTask* operator[](unsigned int _number);
	void link(CInterface* _screen);
	unsigned int get_quantity(void);
	~CTasks();
private:
	struct STaskList
	{
		CTask* task;
		unsigned int number;
		STaskList* next;
	};
	STaskList* tasks;
	CInterface* screen;
	unsigned int quantity;
};