// TestService.h - header file for CTestService class
#pragma once

#include "Init.h"
#include "FViser.h"
#include "Folder.h"
#include "Task.h"
#include "TestInfo.h"
#include "TaskInfo.h"
#include "FilterService.h"
#include "CompilerService.h"
#include "MyFunc.h"
#include "Problem.h"

class CTestService : public CFViser,public CInit
{
public:
	CTestService(CFolder* _folder,CInterface* _screen,CCompilerService* _compiler);
	int update_test(STestInfo& _test_info);
	int update_task(STaskInfo& _task_info);
	int clear(int _tasknumber);
	int test(const char* _solution,const int _task_number);
	~CTestService();
protected:
	struct STaskNode
	{
		CProblem* problem;
		int number;
		STaskNode* next;

		STaskNode(CProblem* _problem,int _number);
		STaskNode* find_number(int _number);
		void add_next(STaskNode* _next);
		~STaskNode();
	};
	STaskNode* tasks;
	CCompilerService* compiler;
	CFilterService* filter;
	virtual int init(char* _buff);
};