// Tester.h - header file for CTester class
#pragma once

#include "CompilerService.h"
#include "TestService.h"
#include "Folder.h"
#include "TaskInfo.h"
#include "Interface.h"
#include "Tasks.h"
#include "Init.h"
#include "Solution.h"
#include "RRData.h"
#include "TestInfo.h"
#include "pr_server.h"
#include "pr_socket.h"
#include "handler.h"
#include "handlers.h"
#include "protocol.h"

class CTester : public CInit
{
public:
	CTester(CInterface* _screen);
	int tester_init(const char* _filename);
	int update_test(STestInfo& _test_info);
	int update_task(STaskInfo& _task_info);
	int init(char* _buff);
	int connect(void);
	void close(void);
	int clear(int _tasknumber);
	void Send(RRData& _out);
	void handle(void);
	int test(SSolution& _solution);
	const char* get_compilers(void);
	~CTester();
protected:
	CCompilerService* compiler;
	CTestService* tester;
	CInterface* screen;
	CFolder* folder;
	CTasks* tasks;
	stdSocket* socket;
	ClientProtocol* protocol;
	t_handlers* handlerMap; 
	Handler* handler;

private:
	char* work_folder;
	char* test_folder;
	char* host_name;
	unsigned int port;
};