// TesterHandler.h - header filr for CTesterHandler class
#pragma once
#include "Tester.h"
#include "RRData.h"

class CTesterHandler
{
public:
	CTesterHandler();
	void receive_400(RRData& _in,RRData& _out);
	void receive_200(RRData& _in,RRData& _out);
	void receive_203(RRData& _in,RRData& _out);
	void receive_301(RRData& _in,RRData& _out);
	void receive_300(RRData& _in,RRData& _out);
	void receive_102(RRData& _in);
	void receive_204(RRData& _in,RRData& _out);
	void receive_406(RRData& _in,RRData& _out);
	~CTesterHandler();
protected:
	void generate_LOGIN(RRData& _out,const char* _compilers);
	void generate_LOGOUT(RRData& _out);
	void generate_GTT(RRData& _out,const char* _tasks);
	void generate_READY(RRData& _out);
	void generate_DONE(RRData& _out,int _result,const char* _message,unsigned int _test);
private:
	int number_of_param(const char* _string);
	void str_param(const char* _string,int _nparam,char* _buff);
	int int_param(const char* _string,int _nparam);
	long m_long_param(const char* _string,int _first,int _all);
	char* m_str_param(const char* _string,int _first,int _all);
	void read_block(const string& _str,unsigned long& _pos);
	bool string_prefix(const string& _str,const unsigned long _pos,const char* _string);
	void find_STR(const string& _str,unsigned long& _pos,const char* _string);
	void skip_STR(const string& _str,unsigned long& _pos,const char* _string);
	void skip_string_prefix(const string& _str,unsigned long& _pos, const char* _string);
	void read_skip_number(const string& _str,unsigned long& _pos,long& _number);
	void read_skip_string(const string& _str,unsigned long& _pos,char* _buff);
	void read_id_value(const string& _str,unsigned long& _pos,const char* _id,long& _number);
	void read_string_value(const string& _str,unsigned long& _pos,const char* _id,char* _buff);
	void skip_prefix(const string& _str,unsigned long& _pos,const char* _prefix);
	void read_body(const string& _str,unsigned long& _pos,const unsigned long _length,char* _buff);
	void read_test_task_block(const string& _str,unsigned long& _pos,STestInfo& _test_info,STestInfo::SBody& _body);
	void read_task_block(const string& _str,unsigned long& _pos,STestInfo& _test_info,STestInfo::SBody& _body);
	void read_task_compiled_block(const string& _str,unsigned long& _pos,STestInfo& _test_info,STestInfo::SBody& _body);

	void generate_protocol(RRData::t_protocol& _protocol);
	CTester* tester;
	CInterface* screen;
	int error_code;
};