// Compiler.cpp - implementation file for CCompiler class
#include "Compiler.h"
#include "Interface.h"
#include "Folder.h"
#include "FViser.h"
#include "MyFunc.h"
#include "Exec.h"
#include <string.h>
#include <windows.h>
#include <stdio.h>
#include "Define.h"

CCompiler::CCompiler(CFolder* _folder,CInterface* _screen,const char* _file,
					 const char* _options,const char* _work_folder,const char* _extens,
					 unsigned int _timeout):
	CExec(_folder,_screen)
{
	char _msg[100];

	compiler_file=new char[strlen(_file)+1];
	strcpy(compiler_file,_file);
	sprintf(_msg,"\nexecute file \"%s\"",compiler_file);
	screen->print(_msg);
	
	options=new char[strlen(_options)+1];
	strcpy(options,_options);
	sprintf(_msg,"\ncommand line to \"%s\"",options);
	screen->print(_msg);

	extension=new char[strlen(_extens)+1];
	strcpy(extension,_extens);
	sprintf(_msg,"\nextension to \"%s\"",extension);
	screen->print(_msg);

	work_folder=new char[strlen(_work_folder)+1];
	strcpy(work_folder,_work_folder);
	sprintf(_msg,"\nwork folder to \"%s\"",work_folder);
	screen->print(_msg);

	time_out=_timeout;
	sprintf(_msg,"\ntime limit to %lums",time_out);
	screen->print(_msg);
};

int CCompiler::compile(const char* _source)
{
	char _cmdline[MAX_CMDLINE_LENGTH];
	char* _src=new char[strlen(_source)+strlen(extension)+4];
	char* _exe=new char[strlen(_source)+strlen(extension)+4];
	int _res=AER_NO_ERROR;
	try
	{
		strcpy(_src,_source);
		strcat(_src,".");
		strcat(_src,extension);
		if((_res=folder->rename_file(_src,_source))!=AER_NO_ERROR)
			throw _res;
		strcpy(_cmdline,options);
		strrep(_cmdline,SOURCE_PLACE,_src);
		strrep(_cmdline,FOLDER_PLACE,folder->get_wf());
		
		screen->print("\n\nStart compiling solution");

		if((_res=execute(compiler_file,_cmdline,work_folder,time_out))!=AER_NO_ERROR)
			throw _res;

		strcpy(_exe,_source);
		strcat(_exe,".exe");
		if(!folder->file_exists(_exe))
			throw ERR_COMPILER;
		if((_res=folder->rename_file(_source,_src))!=AER_NO_ERROR)
			throw _res;
		screen->print("\n done.");
	}
	catch(int _error)
	{
		screen->print("\n error.");
		_res=_error;
	}
	delete[] _src;
	if(_res==ERR_RUNTIME)
		_res=ERR_COMPILER;
	return _res;
};

CCompiler::~CCompiler()
{
	delete work_folder;
	delete compiler_file;
	delete options;
}