// Exec.cpp - implementation of CExec class
#include "Exec.h"
#include "Define.h"
#include "FViser.h"
#include "Folder.h"
#include "Interface.h"
#include "MyFunc.h"
#include <string.h>
#include <windows.h>
#include <stdio.h>

CExec::CExec(CFolder* _folder,CInterface* _screen):
	CFViser(_folder,_screen)
{
	// do nothing
};

int CExec::execute(const char* _file,const char* _cmdline,const char* _work_folder,
				   unsigned long _timeout,unsigned long _memory)
{
	int _res=EXC_DONE;
	char* _file_encode=create_encode_string(_file);
	char* _cmdline_encode=create_encode_string(_cmdline);
	char* _work_folder_encode=create_encode_string(_work_folder);
	char* _timeout_encode=create_encode_number(_timeout);
	char* _memory_encode=create_encode_number(_memory);
	try
	{
		char* _cmd=new char[strlen(_file_encode)+strlen(_cmdline_encode)+strlen(_timeout_encode)+
			strlen(_work_folder_encode)+strlen(_memory_encode)+strlen(EXC_FILE)+strlen(EXC_TIMEOUT)+
			strlen(EXC_CMDLINE)+strlen(EXC_SPACELIM)+40];
		sprintf(_cmd,"%s %s %s %s %s %s %s %s %s %s %s ","ComExec.exe ",EXC_FILE,_file_encode,EXC_CMDLINE,
			_cmdline_encode,EXC_WORKFOLDER,_work_folder_encode,EXC_TIMEOUT,_timeout_encode,
			EXC_SPACELIM,_memory_encode);

		STARTUPINFO _si;
		PROCESS_INFORMATION _pi;
		ZeroMemory(&_si,sizeof(_si));
		_si.cb=sizeof(_si);
		ZeroMemory(&_pi,sizeof(_pi));

		if(CreateProcess(NULL,_cmd,NULL,NULL,FALSE,CREATE_NO_WINDOW,NULL,NULL,&_si,&_pi)==0)
			throw RER_CREATE_PROCESS;
		
		unsigned long _result=WaitForSingleObject(_pi.hProcess,_timeout+EXC_TIME_LIMIT);
		if(_result==WAIT_TIMEOUT)
		{
			TerminateProcess(_pi.hProcess,0);
			throw RER_COMEXEC_TIMEOUT;
		};
		GetExitCodeProcess(_pi.hProcess,&_result);
		_res=(int)_result;
		CloseHandle(_pi.hProcess);
		CloseHandle(_pi.hThread);
		delete[] _cmd;
	}
	catch(int _error)
	{
		_res=_error;
	};
	delete[] _file_encode;
	delete[] _cmdline_encode;
	delete[] _timeout_encode;
	delete[] _memory_encode;
	delete[] _work_folder_encode;
	return _res;
};

inline char* CExec::create_encode_string(const char* _string)
{
	char* _str=new char[2*strlen(_string)+10];
	int _len=0;
	_len=base64_encode_binary(_str,(const unsigned char*)_string,strlen(_string));
	_str[_len]='\0';

	return _str;
};

inline char* CExec::create_encode_number(unsigned long _number)
{
	char* _n=new char[20];
	sprintf(_n,"%lu",_number);
	char* _str=create_encode_string(_n);
	delete[] _n;
	return _str;
}

CExec::~CExec()
{
	// do nothing
};