// FilterService.cpp - implementation of CFilterService class
#include "FilterService.h"
#include "Exec.h"
#include "Define.h"
#include <stdio.h>
#include <string.h>
#include <windows.h>

CFilterService::CFilterService(CFolder* _folder,CInterface* _screen):
	CExec(_folder,_screen)
{
	strcpy(razdel,"\n\r \t");
};
char* CFilterService::cut_start_end(char *f,long len)//ochischaet nachalo i conec ot razdelitelej
{
	f[len--]='\0';
	while(len>=0 && strchr(razdel,f[len]))
		f[len--]='\0';
	char *f1=f;
	while(*f1!='\0' && strchr(razdel,*f1))
		f1++;
	return f1;
};

char CFilterService::gtnext(char*& p)
{
	bool space=false;
	bool enter=false;
	while(strchr(razdel,*p))
	{
		switch(*p)
		{
		case '\n':
			enter=true;
			break;
		case '\r':
			enter=true;
			break;
		default:
			space=true;
			break;
		};
		p++;
	};
	if(enter==true)
		return 13;
	if(space==true)
		return 32;
	return '\0';
};

int CFilterService::std_filter1(const char* _toutput)
{
	int _res=AER_NO_ERROR;
	char* f1=NULL;
	char* f2=NULL;
	try
	{
		HANDLE handle1=CreateFile(_toutput,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(handle1==INVALID_HANDLE_VALUE)
			throw RER_CREATE_FILE;
		unsigned long len,len1=GetFileSize(handle1,NULL);
		f1=new char[len1+10];
		f2=new char[len1+10];
		int i2=0;
		if(ReadFile(handle1,f1,len1,&len,NULL)==0)
			throw RER_READ_FILE;
		if(len1!=len)
			throw RER_READ_FILE;
		if(CloseHandle(handle1)==0)
			throw RER_CLOSE_FILE;

		char* p=cut_start_end(f1,long(len1));
		char ch;
		while(*p!='\0')
		{
			ch=gtnext(p);
			if(ch!='\0')
			{
				if(ch==13)
				{
					f2[i2++]='\r';
					f2[i2++]='\n';
				}else
					f2[i2++]=' ';					
			}
			while(!strchr(razdel,*p))
				f2[i2++]=(char)tolower(*(p++));
		}
		f2[i2]='\0';

		HANDLE handle2=CreateFile(_toutput,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(handle2==INVALID_HANDLE_VALUE)
			throw RER_CREATE_FILE;
		unsigned long len2=i2;

		if(WriteFile(handle2,f2,len2,&len,NULL)==0)
			throw RER_WRITE_FILE;
		if(len2!=len)
			throw RER_WRITE_FILE;
		
		if(CloseHandle(handle2)==0)
			throw RER_CLOSE_FILE;
	}
	catch(int _error)
	{
		_res=_error;
	};
	delete[] f1;
	delete[] f2;
	return _res;
};

int CFilterService::filter2(const char* _toutput,const char* _grammar)
{
	return AER_NO_ERROR;
};

int CFilterService::std_filter2(const char* _toutput)
{
	return AER_NO_ERROR;
};

int CFilterService::filter3(const char* _toutput,const char* _input,const char* _checker)
{
	return AER_NO_ERROR;
};

int CFilterService::std_filter3(const char* _toutput,const char* _output)
{
	int _res=AER_NO_ERROR;
	char* buf1=NULL;
	char* buf2=NULL;
	HANDLE handle1,handle2;
	try
	{
		handle1=CreateFile(_toutput,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		handle2=CreateFile(_output,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(handle1==INVALID_HANDLE_VALUE||handle2==INVALID_HANDLE_VALUE)
			throw RER_CREATE_FILE;
		unsigned long len,len1=GetFileSize(handle1,NULL);
		unsigned long len2=GetFileSize(handle2,NULL);
		if(len1!=len2)
			throw ERR_WRONG_ANSWER;
		buf1=new char[len1+2];
		buf2=new char[len1+2];
		if(ReadFile(handle1,buf1,len1,&len,NULL)==0)
			throw RER_READ_FILE;
		if(len1!=len)
			throw RER_READ_FILE;
		if(ReadFile(handle2,buf2,len2,&len,NULL)==0)
			throw RER_READ_FILE;
		if(len2!=len)
			throw RER_READ_FILE;
		if(memcmp(buf1,buf2,len1)!=0)
			throw ERR_WRONG_ANSWER;
	}
	catch(int _error)
	{
		_res=_error;
	};
	delete[] buf1;
	delete[] buf2;
	if(CloseHandle(handle1)==0)
		throw RER_CLOSE_FILE;
	if(CloseHandle(handle2)==0)
		throw RER_CLOSE_FILE;
	return _res;
};

CFilterService::~CFilterService()
{
	//do nothing
};
