// Init.cpp - implementation for CInit class
#include "Init.h"
#include "Define.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

CInit::CInit()
{
	isinit=false;
}

int CInit::initialization(char* _buff)
{
	if(isinit) return AER_NO_ERROR;
	int _res=init(_buff);
	if(_res==AER_NO_ERROR)
		isinit=true;
	return _res;
};

bool CInit::get_uint(const char* _buff, const char* _name, unsigned int* _value)
{
	if(buffer_copy(_buff,_name)==false)
		return false;
	*_value=atoi(buffer);
	return true;
};

bool CInit::get_string(const char* _buff, const char* _name, char* _string)
{
	if(!buffer_copy(_buff,_name))
		return false;
	strcpy(_string,buffer);
	return true;
};

bool CInit::get_bool(const char* _buff, const char* _name, bool* _value)
{
	if(!buffer_copy(_buff,_name))
		return false;
	for(char* i=buffer;*i!='\0';i++)
		*i=(char)tolower(*i);
	if(strcmp(buffer,"true")==0)
		*_value=true;
	else
		*_value=false;
	return true;
};

bool CInit::is_init(void)
{
	return isinit;
}

bool CInit::buffer_copy(const char* _buff, const char* _name)
{
	char* _p=strstr(_buff,_name);
	if(_p==NULL)
		return false;
	while(*(_p++)!='=');
	for(char* _t=buffer;*_p!='\x0d';*(_t++)=*(_p++));
	*_t='\0';
	return true;
};