// MyFync.cpp - implementation of my functions
#include "MyFunc.h"
#include "Define.h"
#include <string.h>

static char str_no_error[]="no error";
static char str_compiler_error[]="compiler error";
static char str_wrong_answer[]="wrong answer";
static char str_time_out[]="time out";
static char str_runtime[]="run time error";
static char str_wrong_output[]="output format";
static char str_security[]="security_error";
static char str_wrong_task[]="wrong task number";
static char str_wrong_compiler[]="wrong compiler line";
static char str_cant_open_file[]="error while open file";
static char str_cant_read_file[]="error while read file";
static char str_cant_close_file[]="error while close file handle";
static char str_no_information[]="cant fing important information in ini file";
static char str_unknown[]="unknown_error";

static char buff[10000];

// get detailed error description
const char* get_error_string(int _error)
{
	switch(_error)
	{
	case IER_NO_INFORMATION:
		return (const char*)str_no_information;
	case IER_CANT_CLOSE_FILE:
		return (const char*)str_cant_close_file;
	case IER_CANT_READ_FILE:
		return (const char*)str_cant_read_file;
	case AER_NO_ERROR:
		return (const char*)str_no_error;
	case ERR_COMPILER:
		return (const char*)str_compiler_error;
	case ERR_WRONG_ANSWER:
		return (const char*)str_wrong_answer;
	case ERR_TIME_OUT:
		return (const char*)str_time_out;
	case ERR_RUNTIME:
		return (const char*)str_runtime;
	case ERR_WRONG_OUTPUT:
		return (const char*)str_wrong_output;
	case ERR_SECURITY:
		return (const char*)str_security;
	case AER_WRONG_TASK:
		return (const char*)str_wrong_task;
	case AER_WRONG_COMPILER:
		return (const char*)str_wrong_compiler;
	case IER_CANT_OPEN_FILE:
		return (const char*)str_cant_open_file;
	default:
		return (const char*)str_unknown;
	};
};

// strrep finds all substrings _find in _sourse and
// replaces its with _replace
int strrep(char* _source, const char* _find, const char* _replace)
{
	char* _begin=_source;
	char* _end=strstr(_source,_find);
	char* _p=buff;
	char* _t;
	int _i=0;

	while(_end!=NULL)
	{
		_i+=1;
		while(_begin!=_end)
			*(_p++)=*(_begin++);
		_begin=_end;
		while(*_begin==_find[_begin-_end] && *_begin!='\0')
			_begin++;
		_t=_p;
		while(_replace[_p-_t]!='\0')
			*(_p++)=_replace[_p-_t];
		_end=strstr(_begin,_find);
	}
	while(*_begin!='\0')
		*(_p++)=*(_begin++);
	*_p='\0';
	
	strcpy(_source,buff);
	return _i;
};

// encode string string to encoded
int base64_encode_binary(char *encoded, const unsigned char *string, int len)
{
	
	char basis_64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

    int i;
    char *p;

    p = encoded;
    for (i = 0; i < len - 2; i += 3) {
	*p++ = basis_64[(string[i] >> 2) & 0x3F];
	*p++ = basis_64[((string[i] & 0x3) << 4) |
	                ((int) (string[i + 1] & 0xF0) >> 4)];
	*p++ = basis_64[((string[i + 1] & 0xF) << 2) |
	                ((int) (string[i + 2] & 0xC0) >> 6)];
	*p++ = basis_64[string[i + 2] & 0x3F];
    }
    if (i < len) {
	*p++ = basis_64[(string[i] >> 2) & 0x3F];
	if (i == (len - 1)) {
	    *p++ = basis_64[((string[i] & 0x3) << 4)];
	    *p++ = '=';
	}
	else {
	    *p++ = basis_64[((string[i] & 0x3) << 4) |
	                    ((int) (string[i + 1] & 0xF0) >> 4)];
	    *p++ = basis_64[((string[i + 1] & 0xF) << 2)];
	}
	*p++ = '=';
    }

    *p++ = '\0';
    return p - encoded;
};

// decode bufcoded to dufencoded
int base64_decode_binary(unsigned char *bufplain, const char *bufcoded)
{
	unsigned char pr2six[256] =
{
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 62, 64, 64, 64, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 64, 64, 64, 64, 64, 64,
    64,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 64, 64, 64, 64, 64,
    64, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64
};

    int nbytesdecoded;
    register const unsigned char *bufin;
    register unsigned char *bufout;
    register int nprbytes;

    bufin = (const unsigned char *) bufcoded;
    while (pr2six[*(bufin++)] <= 63);
    nprbytes = (bufin - (const unsigned char *) bufcoded) - 1;
    nbytesdecoded = ((nprbytes + 3) / 4) * 3;

    bufout = (unsigned char *) bufplain;
    bufin = (const unsigned char *) bufcoded;

    while (nprbytes > 4) {
	*(bufout++) =
	    (unsigned char) (pr2six[*bufin] << 2 | pr2six[bufin[1]] >> 4);
	*(bufout++) =
	    (unsigned char) (pr2six[bufin[1]] << 4 | pr2six[bufin[2]] >> 2);
	*(bufout++) =
	    (unsigned char) (pr2six[bufin[2]] << 6 | pr2six[bufin[3]]);
	bufin += 4;
	nprbytes -= 4;
    }

    /* Note: (nprbytes == 1) would be an error, so just ingore that case */
    if (nprbytes > 1) {
	*(bufout++) =
	    (unsigned char) (pr2six[*bufin] << 2 | pr2six[bufin[1]] >> 4);
    }
    if (nprbytes > 2) {
	*(bufout++) =
	    (unsigned char) (pr2six[bufin[1]] << 4 | pr2six[bufin[2]] >> 2);
    }
    if (nprbytes > 3) {
	*(bufout++) =
	    (unsigned char) (pr2six[bufin[2]] << 6 | pr2six[bufin[3]]);
    }

    nbytesdecoded -= (4 - nprbytes) & 3;
    return nbytesdecoded;
};