// Parse.cpp - useful parse functions
#include "Parse.h"
#include <string.h>


bool string_prefix(const string& _str,const unsigned long _pos,const char* _string)
{
	long i;
	for(i=0;_str[_pos+i]==_string[i] && _string[i]!='\0';i++);
	return (_string[i]=='\0');
};

void find_STR(const string& _str,unsigned long& _pos,const char* _string)
{
	_pos=_str.find(_string,_pos);
};

void skip_STR(const string& _str,unsigned long& _pos,const char* _string)
{
	unsigned long _next=_str.find(_string,_pos);
	if(_next!=_pos) return;
	_pos+=strlen(_string);
	skip_STR(_str,_pos,_string);
};

void skip_string_prefix(const string& _str,unsigned long& _pos, const char* _string)
{
	long i;
	for(i=0;_str[_pos+i]==_string[i] && _string[i]!='\0';i++);
	if(_string[i]!='\0')
		throw RCR_WRONG_ANSWER;
	_pos+=i;
};

void read_skip_number(const string& _str,unsigned long& _pos,long& _number)
{
	char* _numb;
	long i;
	for(i=0;isspace(_str[_pos+i]);i++);
	_pos+=i;
	for(i=0;isdigit(_str[_pos+i]);i++);
	_numb=new char[i+1];
	for(i=0;isdigit(_str[_pos+i]);i++)
		_numb[i]=_str[_pos+i];
	_numb[i]='\0';
	_pos+=i;
	_number=atol(_numb);
	if(strcmp(_numb,"0")!=0 && _number==0)
		throw RCR_WRONG_ANSWER;
	delete[] _numb;
};

void read_skip_string(const string& _str,unsigned long& _pos,char* _buff)
{
	unsigned long _last_pos;
	long i;
	for(i=0;isspace(_str[_pos+i]);i++);
	_pos+=i;
	_last_pos=_pos;
	find_STR(_str,_last_pos,HDR_CRLF);
	for(i=0;_pos+i<_last_pos;i++)
		_buff[i]=_str[_pos+i];
	_buff[i]='\0';
	_pos+=i;
};

void read_id_value(const string& _str,unsigned long& _pos,const char* _id,long& _number)
{
	skip_string_prefix(_str,_pos,_id);
	read_skip_number(_str,_pos,_number);
	skip_STR(_str,_pos,HDR_SPACE);
};

void read_string_value(const string& _str,unsigned long& _pos,const char* _id,char* _buff)
{
	skip_string_prefix(_str,_pos,_id);
	read_skip_string(_str,_pos,_buff);
	skip_STR(_str,_pos,HDR_SPACE);
};

void skip_prefix(const string& _str,unsigned long& _pos,const char* _prefix)
{
	skip_string_prefix(_str,_pos,_prefix);
	skip_STR(_str,_pos,HDR_SPACE);
};

void read_body(const string& _str,unsigned long& _pos,const unsigned long _length,char* _buff)
{
	long i,j=0,_old_pos;
	for(i=0;i<_length;i++)
	{
		if(string_prefix(_str,_pos,HDR_CRLF))
		{
			_old_pos=_pos;
			skip_STR(_str,_pos,HDR_CRLF);
			i+=_pos-_old_pos;
			if(i>=_length) break;
		};
		_buff[j++]=_str[_pos++];
	};
	_buff[j]=0;
};

void read_test_task_block(const string& _str,unsigned long& _pos,STestInfo& _test_info,STestInfo::SBody& _body)
{
	long _length;
	read_id_value(_str,_pos,"Task-Number:",_test_info.task_number);
	read_id_value(_str,_pos,"Test-Number:",_test_info.test_number);
	read_id_value(_str,_pos,"Content-Length:",_length);
	
	_body.body=new char[_length+2];
	_body.size=_length;
	_body.exist=true;
	read_body(_str,_pos,_length,_body.body);
};

void read_task_block(const string& _str,unsigned long& _pos,STestInfo& _test_info,STestInfo::SBody& _body)
{
	long _length;
	read_id_value(_str,_pos,"Task-Number:",_test_info.task_number);
	read_id_value(_str,_pos,"Content-Length:",_length);
	
	_body.body=new char[_length+2];
	_body.size=_length;
	_body.exist=true;
	read_body(_str,_pos,_length,_body.body);
};

void read_task_compiled_block(const string& _str,unsigned long& _pos,STestInfo& _test_info,STestInfo::SBody& _body)
{
	long _length;
	read_id_value(_str,_pos,"Task-Number:",_test_info.task_number);
	_body.compile=true;
	_body.compiler=new char[10];
	read_string_value(_str,_pos,"Compiler:",_body.compiler);
	read_id_value(_str,_pos,"Content-Length:",_length);
	
	_body.body=new char[_length+2];
	_body.size=_length;
	_body.exist=true;
	read_body(_str,_pos,_length,_body.body);
};

int int_param(const char* _string,int _nparam)
{
	char _number[10];
	str_param(_string,_nparam,_number);
	int _res=atoi(_number);
	if(strcmp(_number,"0")!=0 && _res==0)
		throw RCR_WRONG_ANSWER;
	return _res;
};

void str_param(const char* _string,int _nparam,char* _buff)
{
	int i,j=0;
	for(i=0;j<_nparam;i++)
		if(_string[i]==';') j++;
	for(j=0;_string[j+i]!=';' && _string[j+i]!='\0';j++)
		_buff[j]=_string[j+i];
	_buff[j]='\0';
};

char* m_str_param(const char* _string,int _first,int _all)
{
	char _str[100];
	int i,j,_find;
	for(i=0;i<_all;i++)
	{
		str_param(_string,i,_str);
		for(j=0;_str[j]!='-';j++);
		_str[j]='\0';
		_find=atoi(_str);
		if(_find==_first)
		{
			_str[j++]='-';
			char* _res=new char[strlen(_str+j)+1];
			strcpy(_res,_str+j);
			return _res;
		};
	};
	return NULL;
};

long m_long_param(const char* _string, int _first,int _all)
{
	char* _str=m_str_param(_string,_first,_all);
	long _res=atol(_str);
	delete _str;
	if(strcmp(_str,"0")!=0 && _res==0)
		throw RCR_WRONG_ANSWER;
	return _res;
};

int number_of_param(const char* _string)
{
	int i,_number=0;
	for(i=0;i<strlen(_string);i++)
		if(_string[i]==';') _number++;
	return _number+1;
};