#include <rrdata.h>

using std::ostream;

ostream & operator << (ostream &os, const RRData::t_protocol::t_version &o)
{
	os << o.major << '.' << o.minor;
	return os;
}

ostream & operator << (ostream &os, const RRData::t_protocol &o)
{
	os << o.name << '/' << o.version;
	return os;
}

ostream & operator << (ostream &os, const RRData::t_command &o)
{
	os << o.name;
	if (o.parameter.length() > 0)
		os << ' ' << o.parameter;
	return os;
}



ostream & operator << (ostream &os, const RRData &o)
{
	RRData::t_headers::const_iterator e = o.headers.end();
	RRData::t_headers::const_iterator i = o.headers.begin();
	while (i != e){
		os << i->first.c_str() << ": " << i->second.c_str() << '\n';
		i++;
	}
	os << '\n';
	if(o.body.size()) os.write(o.body.c_str(), o.body.size());
	return os;
}
