// Tasks.cpp - implementation file for CTasks class
#include "Tasks.h"
#include "Task.h"
#include "Interface.h"
#include "Counter.h"
#include <string.h>

CTasks::CTasks()
{
	tasks=NULL;
	screen=NULL;
	quantity=0;
};

CTask* CTasks::operator [](unsigned int _number)
{
	STaskList* _p=tasks;
	while(_p!=NULL)
	{
		if(_p->number==_number)
			return _p->task;
		_p=_p->next;
	};
	return NULL;
};

void CTasks::update_task(unsigned int _number,const char* _name)
{
	STaskList* _p=tasks;
	while(_p!=NULL)
	{
		if(_p->number==_number)
		{
			delete _p->task;
			_p->task=new CTask(_name,this);
			screen->update_tasks();
			return;
		};
		_p=_p->next;
	};
	_p=new STaskList;
	_p->task=new CTask(_name,this);
	_p->next=tasks;
	_p->number=_number-1;
	tasks=_p;
	quantity++;
	screen->update_tasks();
};

void CTasks::clear(void)
{
	total=0;
	accept=0;
	refuse=0;
	if(screen!=NULL)
		screen->update_tasks();
};

void CTasks::inc_accept(void)
{
	accept+=1;
	if(screen!=NULL)
		screen->update_tasks();
};

void CTasks::inc_refuse(void)
{
	refuse+=1;
	if(screen!=NULL)
		screen->update_tasks();
};

void CTasks::inc_total(void)
{
	total+=1;
	if(screen!=NULL)
		screen->update_tasks();
};

void CTasks::link(CInterface* _screen)
{
	screen=_screen;
};

unsigned int CTasks::get_quantity(void)
{
	return quantity;
};

void CTasks::update(void)
{
	STaskList* _task=tasks;
	clear();
	while(_task!=NULL)
	{
		total+=_task->task->get_total();
		accept+=_task->task->get_accept();
		refuse+=_task->task->get_refuse();
	};
	screen->update_tasks();
};

CTasks::~CTasks()
{
	while(tasks!=NULL)
	{
		STaskList* p=tasks;
		tasks=tasks->next;
		delete p;
	};
};