// TestInfo.cpp - implementation of STestInfo struct
#include "TestInfo.h"
#include "Define.h"
#include <string.h>

STestInfo::SBody::SBody()
{
	exist=false;
	size=0;
	body=NULL;
	compile=false;
	compiler=NULL;
};

void STestInfo::SBody::clear(void)
{
	exist=false;
	size=0;
	delete[] body;
	body=NULL;
	compile=false;
	delete[] compiler;
	compiler=NULL;
};

STestInfo::SBody::~SBody()
{
	if(exist) delete[] body;
	if(compile) delete[] compiler;
	body=compiler=NULL;
};

STestInfo::STestInfo()
{
	task_number=TST_NO_TASK;
	test_number=TST_NO_TEST;
};

void STestInfo::clear(void)
{
	task_number=TST_NO_TASK;
	test_number=TST_NO_TEST;
	input.clear();
	output.clear();
	filter.clear();
	grammar.clear();
	solution.clear();
};

STestInfo::~STestInfo()
{
	// no action
};
